import java.security.*;
import java.util.*;
class InfoProveedores{

public static void main(String[] args) {
    System.out.println("------------------------------------");
    System.out.println("Proveedores instalados en su sistema");
    System.out.println("------------------------------------");
    Provider[] listaProv = Security.getProviders();
    for (int i = 0; i < listaProv.length; i++) {
      System.out.println("Num. proveedor : "    + (i + 1));
      System.out.println("Name         : "    + listaProv[i].getName());
      System.out.println("Version        : "    + listaProv[i].getVersion());
      System.out.println("Informacion    :\n  " + listaProv[i].getInfo());
      System.out.println("Propiedades    :");

      Enumeration propiedades = listaProv[i].propertyNames();
      while (propiedades.hasMoreElements()) {
          String clave = (String) propiedades.nextElement();
          String valor = listaProv[i].getProperty(clave);
          System.out.println("  " + clave + " = " + valor);
      }
      
      System.out.println("------------------------------------");
    }
  }

}